#include "core/Logger.hpp"

Core::LogLevel Core::logLevel = Core::LogLevel::DEBUG;
static Core::ReportHandler reportHandler = nullptr;
static void* reportData = nullptr;

void Core::setReportHandler(ReportHandler h, void* data) {
    reportHandler = h;
    reportData = data;
}

void Core::callReportHandler(
    LogLevel l, const char* file, int line, const char* report) {
    if(reportHandler != nullptr) {
        reportHandler(l, file, line, reportData, report);
    }
}

const char* Core::getShortFileName(const char* s) {
    const char* r = s;
    while(*s != '\0') {
        if(*(s++) == '/') {
            r = s;
        }
    }
    return r;
}
